/****************************************************************************
 * [S]imulated [M]edieval [A]dventure multi[U]ser [G]ame      |   \\._.//   *
 * -----------------------------------------------------------|   (0...0)   *
 * SMAUG 1.4 (C) 1994, 1995, 1996, 1998  by Derek Snider      |    ).:.(    *
 * -----------------------------------------------------------|    {o o}    *
 * SMAUG code team: Thoric, Altrag, Blodkai, Narn, Haus,      |   / ' ' \   *
 * Scryn, Rennard, Swordbearer, Gorog, Grishnakh, Nivek,      |~'~.VxvxV.~'~*
 * Tricops and Fireblade                                      |             *
 * ------------------------------------------------------------------------ *
 * Merc 2.1 Diku Mud improvments copyright (C) 1992, 1993 by Michael        *
 * Chastain, Michael Quan, and Mitchell Tse.                                *
 * Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,          *
 * Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.     *
 * ------------------------------------------------------------------------ *
 * Remort Code by Xerves of Rafermand (mud.rafermand.net: 3002)             *
 * Note:  I don't use this code anymore in my 2.x code                      *
 * ------------------------------------------------------------------------ *
 *			 Remort Commands           			    *
 ****************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "mud.h"

/* Remort Commands -- Xerves */
void do_remor( CHAR_DATA *ch, char *argument )
{
    send_to_char( "If you want to REMORT, you must spell it out.\n\r", ch );
    return;
}

void do_remort( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;
    char arg[MAX_INPUT_LENGTH];
    int iClass, iRace;
    CHAR_DATA *oldch;
    OBJ_DATA *obj;
    OBJ_INDEX_DATA *obj_index;
    int iLang;
    
    if ( IS_NPC(ch) || ( d = ch->desc ) == NULL )
	return;
	
    if (ch->level < LEVEL_HERO && ch->pcdata->tier <= 1)
    {
       send_to_char("You have yet to possess the skills to remort, try reaching avatar first.\n\r", ch);
       return;
    }
    if (argument[0] == '\0')
    {
       if (REMORT_NO_RACE == TRUE)
       {
          send_to_char("Syntax: remort <name of class>\n\r", ch);
          send_to_char("Syntax: remort class list\n\r", ch);
          return;
       }
       else
       {
          send_to_char("Syntax: remort <name of class> <name of race>\n\r", ch);
          send_to_char("Syntax: remort class list\n\r", ch);
          send_to_char("Syntax: remort race list\n\r", ch);
          return;
       }
    }

    if ( ch->level > LEVEL_HERO )
    {
        send_to_char( "Remort is for mortals only, trust me, you don't want to do this.\n\r", ch);
        return;
    }
    
    if (ch->fighting)
    {
       send_to_char("You need to stop fighting, hard to concentrage while being attacked you know!\n\r", ch);
       return;
    }
    if (ch->position != POS_STANDING)
    {
       send_to_char("You can only remort if you are standing up, so please be standing.\n\r", ch);
       return;
    }
    if (!str_cmp(argument, "class list"))
    {
       if (ch->level == LEVEL_HERO)
          ch->pcdata->tier++;
       for ( iClass = 0; iClass < MAX_PC_CLASS; iClass++ )
       {
	  if ( class_table[iClass]->who_name && class_table[iClass]->who_name[0] != '\0' && class_table[iClass]->remort_class <= ch->pcdata->tier-1)
	     ch_printf(ch, "%s\n\r", class_table[iClass]->who_name);
       }
       if (ch->level == LEVEL_HERO)
          ch->pcdata->tier--;
       return;
    }
    if (!str_cmp(argument, "race list") && REMORT_NO_RACE == FALSE)
    {
       if (ch->level == LEVEL_HERO)
          ch->pcdata->tier++;
       for ( iRace = 0; iRace < MAX_PC_RACE; iRace++ )
       {
	  if ( race_table[iRace]->race_name[0] != '\0' && race_table[iRace]->remort_race <= ch->pcdata->tier-1 && iRace != RACE_VAMPIRE)
	     ch_printf(ch, "%s\n\r", race_table[iRace]->race_name);
       }
       if (ch->level == LEVEL_HERO)
          ch->pcdata->tier--;
       return;
    }
    argument = one_argument(argument, arg);
    if (REMORT_NO_RACE == FALSE)
    {
       if (ch->level == LEVEL_HERO)
          ch->pcdata->tier++;
       for ( iClass = 0; iClass < MAX_PC_CLASS; iClass++ )
       {
	  if ( class_table[iClass]->who_name[0] != '\0' && class_table[iClass]->remort_class <= ch->pcdata->tier-1)
	  {
	     if (!str_cmp(arg, class_table[iClass]->who_name))
	        break;
	  }
       }
       if (iClass == MAX_PC_CLASS)
       {
          if (ch->level == LEVEL_HERO)
             ch->pcdata->tier--;
          send_to_char("That is not a valid class.\n\r", ch);
          return;
       }
       for ( iRace = 0; iRace < MAX_PC_RACE; iRace++ )
       {
	  if ( race_table[iRace]->race_name[0] != '\0' && race_table[iRace]->remort_race <= ch->pcdata->tier-1 && iRace != RACE_VAMPIRE)
	  {
	     if (!str_cmp(argument, race_table[iRace]->race_name))
	        break;
	  }
       }
       if (iRace == MAX_PC_RACE)
       {
          if (ch->level == LEVEL_HERO)
             ch->pcdata->tier--;
          send_to_char("That is not a valid race.\n\r", ch);
          return;
       }
    }
    else
    {
       if (ch->level == LEVEL_HERO)
          ch->pcdata->tier++;
       for ( iClass = 0; iClass < MAX_PC_CLASS; iClass++ )
       {
	  if ( class_table[iClass]->who_name[0] != '\0' && class_table[iClass]->remort_class <= ch->pcdata->tier-1)
	  {
	     if (!str_cmp(arg, class_table[iClass]->who_name))
	        break;
	  }
       }
       if (iClass == MAX_PC_CLASS)
       {
          if (ch->level == LEVEL_HERO)
             ch->pcdata->tier--;
          send_to_char("That is not a valid class.\n\r", ch);
          return;
       }
    }
    //now for the fun, lets begin this process....  
    act(AT_WHITE, "$n starts to glow white as $e starts to remort into %s new body.", ch, NULL, NULL, TO_ROOM);
    if (REMORT_NO_RACE == FALSE)
       ch_printf(ch, "You are now remorting, you will lose all your equipment and stats and start over as\n\ryour new race and class.\n\r");
    else
       ch_printf(ch, "You are now remorting, you will lose all your equipment and stats and start over as\n\ryour new class.\n\r");
       
    d = ch->desc;
    oldch = ch;
    d->character->desc = NULL;
    d->character = NULL;
    load_char_obj(d, capitalize( oldch->name ), TRUE);
    ch = d->character;
    DISPOSE( ch->pcdata->pwd );
    ch->pcdata->pwd	= str_dup( oldch->pcdata->pwd );
    DISPOSE( ch->pcdata->rank );
    ch->pcdata->rank    = str_dup( oldch->pcdata->rank );
    set_title( ch, oldch->pcdata->title );
    if (REMORT_NO_RACE == TRUE)
       ch->race = oldch->race;
    else
       ch->race = iRace;
    ch->class = iClass;
    ch->pcdata->tier = 2;
    ch->max_hit  = 20;   /* Max HP/Mana/Move is stock, if you need something different change it -- Xerves */
    ch->hit = ch->max_hit;
    ch->max_mana = 100;
    ch->mana = ch->max_mana;
    ch->max_move = 100;
    ch->move = ch->max_move;
    ch->gold = 0;
    ch->pcdata->favor = 0;
    ch->practice = 0;
    //Below is what is in comm.c when you first create a character, replace with any info you might have
    //or removed. -- Xerves    
    
    //Change these two lines if you don't want them in their own clan.
    ch->pcdata->clan_name = STRALLOC( oldch->pcdata->clan_name );
    ch->pcdata->clan	  = oldch->pcdata->clan;
    
    //Smaug 1.4a code
    switch ( class_table[ch->class]->attr_prime )
    {
       case APPLY_STR: ch->perm_str = 16; break;
       case APPLY_INT: ch->perm_int = 16; break;
       case APPLY_WIS: ch->perm_wis = 16; break;
       case APPLY_DEX: ch->perm_dex = 16; break;
       case APPLY_CON: ch->perm_con = 16; break;  
       case APPLY_CHA: ch->perm_cha = 16; break;
       case APPLY_LCK: ch->perm_lck = 16; break;
    }

    ch->perm_str	 += race_table[ch->race]->str_plus;
    ch->perm_int	 += race_table[ch->race]->int_plus;
    ch->perm_wis	 += race_table[ch->race]->wis_plus;
    ch->perm_dex	 += race_table[ch->race]->dex_plus;
    ch->perm_con	 += race_table[ch->race]->con_plus;
    ch->perm_cha	 += race_table[ch->race]->cha_plus;
    ch->affected_by	  = race_table[ch->race]->affected;
    ch->perm_lck	 += race_table[ch->race]->lck_plus;
	   
    ch->armor	                += race_table[ch->race]->ac_plus;
    ch->alignment      	        += race_table[ch->race]->alignment;
    ch->attacks                 = race_table[ch->race]->attacks;
    ch->defenses                = race_table[ch->race]->defenses;
    ch->saving_poison_death  	= race_table[ch->race]->saving_poison_death;
    ch->saving_wand  		= race_table[ch->race]->saving_wand;
    ch->saving_para_petri  	= race_table[ch->race]->saving_para_petri;
    ch->saving_breath  		= race_table[ch->race]->saving_breath;
    ch->saving_spell_staff	= race_table[ch->race]->saving_spell_staff;

    ch->height = number_range(race_table[ch->race]->height *.9, race_table[ch->race]->height *1.1);
    ch->weight = number_range(race_table[ch->race]->weight *.9, race_table[ch->race]->weight *1.1);

    //For Paladin's alignment, remove if you have no paladin or don't use this anymore
    if ( ch->class == CLASS_PALADIN )
       ch->alignment = 1000;

    if ( (iLang = skill_lookup( "common" )) < 0 )
       bug( "Nanny: cannot find common language." );
    else
       ch->pcdata->learned[iLang] = 100;
	    	
    for ( iLang = 0; lang_array[iLang] != LANG_UNKNOWN; iLang++ )
       if ( lang_array[iLang] == race_table[ch->race]->language )
          break;
       if ( lang_array[iLang] == LANG_UNKNOWN )
          bug( "Nanny: invalid racial language." );
       else
       {
          if ( (iLang = skill_lookup( lang_names[iLang] )) < 0 )
	     bug( "Nanny: cannot find racial language." );
	  else
	     ch->pcdata->learned[iLang] = 100;
       }

   //You can uncomment that if you want, It gives stats based on your name, I think it is useless and stupid -- Xerves
   //name_stamp_stats( ch );
   
   //Remove these if your stats are different and allow more than 9-18 naturally
   ch->perm_str = UMIN( 18, ch->perm_str );
   ch->perm_wis = UMIN( 18, ch->perm_wis );
   ch->perm_dex = UMIN( 18, ch->perm_dex );
   ch->perm_int = UMIN( 18, ch->perm_int );
   ch->perm_con = UMIN( 18, ch->perm_con );
   ch->perm_cha = UMIN( 18, ch->perm_cha );
   ch->perm_lck = UMIN( 18, ch->perm_lck );
   ch->perm_str = UMAX( 9, ch->perm_str );
   ch->perm_wis = UMAX( 9, ch->perm_wis );
   ch->perm_dex = UMAX( 9, ch->perm_dex );
   ch->perm_int = UMAX( 9, ch->perm_int );
   ch->perm_con = UMAX( 9, ch->perm_con );
   ch->perm_cha = UMAX( 9, ch->perm_cha );
   ch->perm_lck = UMAX( 9, ch->perm_lck );

   ch->level	= 2;
   ch->exp	        = exp_level(ch, 2);
   ch->max_hit      += race_table[ch->race]->hit;
   ch->max_mana     += race_table[ch->race]->mana;
   ch->hit	        = UMAX(1,ch->max_hit);
   ch->mana	        = UMAX(1,ch->max_mana);
   ch->move	        = ch->max_move;
   
   //Below is for the level 2 so you get those stats....
    ch->max_hit	 += UMAX(1, con_app[get_curr_con(ch)].hitp + number_range(
		     class_table[ch->class]->hp_min,
		     class_table[ch->class]->hp_max ));
    ch->max_mana += UMAX(0, class_table[ch->class]->fMana
		     ? number_range(2, (2*get_curr_int(ch)+get_curr_wis(ch))/8)
		     : 0);
    ch->max_move += UMAX(10, number_range( 5, (get_curr_con(ch)+get_curr_dex(ch))/4 ));
    ch->practice += wis_app[get_curr_wis(ch)].practice;
    
    ch->hit = ch->max_hit;
    ch->mana = ch->max_mana;
    ch->move = ch->max_move;
    
   //uncomment the blow if you want titles to change everytime they level...
   /*
   sprintf( buf, "the %s",
   title_table [ch->class] [ch->level]
   [ch->sex == SEX_FEMALE ? 1 : 0] );
   set_title( ch, buf ); */

   //Well if you are using AUTOGOLD now, you probably want it again...
   ch->act = oldch->act; 
   ch->pcdata->flags = oldch->pcdata->flags;

   /* Added by Brittany, Nov 24/96.  The object is the adventurer's guide
      to the realms of despair, part of Academy.are. */
   obj_index = get_obj_index( 10333 );
   if ( obj_index != NULL )
   {
      obj = create_object( obj_index, 0 );
      obj_to_char( obj, ch );
      equip_char( ch, obj, WEAR_HOLD );
   }
   //Give you back that prompt...
   ch->pcdata->prompt = STRALLOC(oldch->pcdata->prompt);
   ch->pcdata->fprompt = STRALLOC(oldch->pcdata->fprompt);
   if ( oldch->pcdata->pet )
      ch->pcdata->pet = oldch->pcdata->pet;
   char_to_room( ch, oldch->in_room );
   ch->position = POS_STANDING;
   add_char(ch);
   //We can finally get rid of this data now...  Don't call for oldch after this.
   extract_char(oldch, TRUE);
   //Lets save
   save_char_obj( ch );
   do_look( ch, "auto" );
}



